from ..tracker import GestureTracker
from utils import PointGesture


class DownGesture(PointGesture):
    _type = 'point_down'


class MoveGesture(PointGesture):
    _type = 'point_move'


class UpGesture(PointGesture):
    _type = 'point_up'


class BasicEventTracker(GestureTracker):
    """
    The main goal of this class is to provide a triggering mechanism for the
    low-level point-down, point-move and point-up events.
    """
    supported_gestures = [DownGesture, MoveGesture, UpGesture]

    def on_point_down(self, event):
        self.trigger(DownGesture(event))

    def on_point_move(self, event):
        self.trigger(MoveGesture(event))

    def on_point_up(self, event):
        self.trigger(UpGesture(event))
