#!/usr/bin/env python
import vtk


def read_obj(filename):
    reader = vtk.vtkOBJReader()
    reader.SetFileName(filename)
    mapper = vtk.vtkPolyDataMapper()
    mapper.SetInput(reader.GetOutput())
    del reader
    return mapper


def main():
    # Create render window and interactor
    ren = vtk.vtkRenderer()
    win = vtk.vtkRenderWindow()
    win.AddRenderer(ren)
    #iren = vtk.vtkRenderWindowInteractor()
    #iren.SetRenderWindow(win)

    # Read OBJ file
    cubemapper = read_obj('cube.obj')

    # Create actor
    cubeactor = vtk.vtkActor()
    cubeactor.SetMapper(cubemapper)
    ren.AddActor(cubeactor)

    #iren.Initialize()
    win.Render()
    #iren.Start()

    try:
        cam = ren.GetActiveCamera()

        while True:
            win.Render()

            # Rotate
            cam.Roll(.01)

            # Horizontal drag
            cam.Azimuth(.01)

            #cam.Elevation(.01)
    except KeyboardInterrupt:
        return


if __name__ == '__main__':
    main()
